<template>
	<mind-view>
		<template v-slot:toolbar-actions>
			<el-button type="primary" size="small" @click="$refs.formulario?.onSubmit()" :disabled="!modificado" >Aplicar Cambios</el-button>
		</template>
		<mind-form  
			v-model="recurso"  v-model:modified="modificado"
			@submit="onSubmit" v-loading="isLoading"
			ref="formulario" 
			>
			<template v-slot="{form}">
					<el-row  >
						<el-col  :lg="12">
							<el-form-item label="Nombre" prop="nombre">
								<el-input v-model="form.nombre"/>
							</el-form-item>
						</el-col>
						<el-col :lg="12">
							<el-form-item label="Nombre Alternativo">
								<el-input v-model="form.nombreAlternativo" />
							</el-form-item>
						</el-col>
					</el-row>
					<el-row  >
						<el-col  :lg="12">
							<el-form-item label="Tipo">
								<el-select v-model="form.tipo">
									<el-option value="Lugar">Lugar</el-option>
									<el-option value="Calle">Calle</el-option>
								</el-select>
							</el-form-item>
						</el-col>
						<el-col :lg="12">
							<el-form-item label="Localidad">
								<el-input v-model="form.localidad" />
							</el-form-item>
						</el-col>
					</el-row>
					<el-row  >
						<el-col  :lg="12">
							<el-form-item label="Uso Frecuente">
								<el-checkbox v-model="form.frecuente" />
							</el-form-item>
						</el-col>
					</el-row>

			</template>
		</mind-form>
	</mind-view>
</template>
<script>
import lugares from '@/model/lugares'

export default {
	async created(){
		this.isLoading = true;
		let id = this.$route.params.id;
		if (id == "new") {
			this.recurso = lugares.new()
		} else {
			this.recurso = await lugares.get(id)

		}
		this.isLoading = false;
	},
	computed: {
		esNuevo() {
			return this.recurso?._isNew
		}
		
	},

	methods: {
		async onSubmit(v) {
			delete(v.ultimaActualizacion)
			delete(v.estado)
			this.recurso = v
			const key = lugares.getKey()
			const esNuevo = this.esNuevo
			if(esNuevo) {
				this.recurso = await lugares.post(this.recurso)
				.then((response)=>{
					const id = response[0][key]
					this.$message({
						type: 'success',
						message: `Comisión creada correctamente`,
					})
					//modifico la ruta
					const path = this.$router.currentRoute.path.replace(/\/new$/, `/${id}`)
					this.$router.replace(path)
				})
			} else {
				this.recurso = await lugares.patch(this.recurso)
				this.$message({
					type: 'success',
					message: "Comisión actualizada correctamente",
				})
			}

		},
	},
	data() {
		return {
			recurso: {},
			modificado: false, 

		}
	}
}
</script>